#include "pch.h"
#include "Logger.h"
#include <ctime>
#include <sstream>

// ̬Աʼ
std::shared_ptr<spdlog::logger> Logger::logger = nullptr;

// ȡ־ʵ
std::shared_ptr<spdlog::logger> Logger::getLogger() {
    if (!logger) {
        const std::string log_dir = "PLA/logs";  // ־Ŀ¼
        ensureLogDir(log_dir);  // ȷĿ¼

        // ̬־ļ + .log
        const std::string log_filename = log_dir + "/"+"VCLog" + ".log";

        // ָ־ļ
        logger = spdlog::daily_logger_mt("daily_logger", log_filename, 0, 0); // ÿ 0 ָ
        logger->set_level(spdlog::level::info);  // Ĭϼ INFO
        spdlog::flush_on(spdlog::level::info);  // Զˢ INFO ϵ־
    }
    return logger;
}

// ־
void Logger::setLogLevel(spdlog::level::level_enum level) {
    getLogger()->set_level(level);
}

// ȷ־Ŀ¼
void Logger::ensureLogDir(const std::string& dir) {
    if (!std::filesystem::exists(dir)) {
        std::filesystem::create_directories(dir);  // Ŀ¼
    }
}
