#include "wrapper.h"
#include "pch.h"
#include "framework.h"
#include "Logger.h"
#include <Windows.h>
#include <iostream>
#include <sstream>
#include <stdexcept>
#include <cstdio>
#include <spdlog/spdlog.h>
#include <spdlog/sinks/basic_file_sink.h>
#include <string.h>



#pragma region 嶯̬غָ
typedef int(__stdcall* LinkDeviceFunc)(const char*);
typedef int(__stdcall* UnlinkDeviceFunc)();
typedef int(__stdcall* PowerOnFunc)(char*, unsigned long*);
typedef int(__stdcall* PowerOffFunc)(char*, unsigned long*);
typedef int(__stdcall* ReadCardFunc)(unsigned int, unsigned int, unsigned int, char*, unsigned long*);
typedef int(__stdcall* WriteCardFunc)(unsigned int, unsigned int, unsigned int, const char*, char*, unsigned long*);
typedef int(__stdcall* ChkSecretFunc)(int, char*, char*, unsigned long*);
typedef int(__stdcall* WriteSecretFunc)(int, char*, char*, unsigned long*);
typedef int(__stdcall* ReadSecretFunc)(int, char*, unsigned long*);
typedef int(__stdcall* HexStrToByteFunc)(const char*, char*);
typedef int(__stdcall* ByteToHexStrFunc)(char*, unsigned int, char*);
typedef int(__stdcall* HexByteToDecFunc)(const char*, unsigned long*);
typedef int(__stdcall* DecToHexByteFunc)(unsigned long, char*);
typedef int(__stdcall* SetKeyVersionFunc)(int, int, char*, unsigned long*);
typedef int(__stdcall* Chk1608SecretFunc)(int, char*, unsigned long*);
typedef int(__stdcall* Authenfic1608Func)(char*, unsigned long*);
typedef int(__stdcall* HexByteToLongFunc)(const char*, unsigned long*);
typedef int(__stdcall* LongToHexByteFunc)(unsigned long, char*);
typedef int(__stdcall* SignatureFunc)(const char*, const char*, int, char*, unsigned long*);
typedef int(__stdcall* VerifySignetFunc)(const char*, const char*, int, const char*, char*, unsigned long*);
typedef int(__stdcall* WriteIDInfoFunc)(const char*, char*, unsigned long*);
typedef int(__stdcall* PINOpfuncFunc)(int, int, const char*, int, char*, unsigned long*);
typedef int(__stdcall* UpdateIDInfoFunc)(const char*, char*, unsigned long*);
typedef int(__stdcall* LockUserCardFunc)(char*, unsigned long*);
typedef int(__stdcall* ReadSamIDInfoFunc)(char*, unsigned long*);
typedef int(__stdcall* GetICCardNoFunc)(int, char*, unsigned long*);
typedef int(__stdcall* PowerOnSamFunc)(char*, unsigned long*);
typedef int(__stdcall* GetUpdateIDRightFunc)(const char*, const char*, char*, unsigned long*);
#pragma endregion

// ̬Dllļ
static HMODULE hDll = nullptr;
auto logger = Logger::getLogger();

/// <summary>
/// ĿDLLļ
/// </summary>
void LoadTargetDll() {
	// жDll
	if (hDll)
	{
		return;
	}
	//LPCWSTR dllRelativePath = L".\\PLA\\UsbDxqDll_10.dll";

	//////  DLL ļ
	//hDll = LoadLibrary(dllRelativePath);
	// DLLļ
	hDll = LoadLibrary(L"UsbDxqDll_10.dll");
	if (!hDll)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		errorMessage << "޷ UsbDxqDll_10.dll: " << GetLastError();
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
}
/// <summary>
/// ͷĿDLLļ
/// </summary>
void __stdcall UnloadTargetDll() {
	// жDll
	if (hDll)
	{
		// ͷĿ DLL
		FreeLibrary(hDll);
		//  Dll 
		hDll = nullptr;
	}
}
/// <summary>
/// 豸ͨѶ
/// </summary>
/// <param name="devPort">豸˿</param>
/// <returns></returns>
int __stdcall OpenComm(const char* devPort) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		LinkDeviceFunc _LinkDevice = (LinkDeviceFunc)GetProcAddress(hDll, "LinkDevice");
		if (!_LinkDevice)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " LinkDevice ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _LinkDevice(devPort);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:OpenComm쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ر豸ͨѶ
/// </summary>
/// <returns></returns>
int __stdcall CloseComm() {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		UnlinkDeviceFunc _UnlinkDevice = (UnlinkDeviceFunc)GetProcAddress(hDll, "UnlinkDevice");
		if (!_UnlinkDevice)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " UnlinkDevice ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _UnlinkDevice();
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:CloseComm쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ICƬϵ
/// </summary>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall PowerOn(char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		PowerOnFunc _PowerOn = (PowerOnFunc)GetProcAddress(hDll, "PowerOn");
		if (!_PowerOn)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " PowerOn ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _PowerOn(receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:PowerOn쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ICƬµ
/// </summary>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall PowerOff(char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		PowerOffFunc _PowerOff = (PowerOffFunc)GetProcAddress(hDll, "PowerOff");
		if (!_PowerOff)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " PowerOff ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _PowerOff(receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:PowerOff쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ȡƬ
/// </summary>
/// <param name="zone">ָȡĿƬ</param>
/// <param name="addr">ʼַ</param>
/// <param name="len">Ҫȡݳ</param>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall ReadCard(unsigned int zone, unsigned int addr, unsigned int len, char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		ReadCardFunc _ReadCard = (ReadCardFunc)GetProcAddress(hDll, "ReadCard");
		if (!_ReadCard)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " ReadCard ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _ReadCard(zone, addr, len, receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:ReadCard쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// д뿨Ƭ
/// </summary>
/// <param name="zone">ָдĿƬ</param>
/// <param name="addr">ʼַ</param>
/// <param name="len">Ҫдݳ</param>
/// <param name="sendData"></param>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall WriteCard(unsigned int zone, unsigned int addr, unsigned int len, const char* sendData, char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		WriteCardFunc _WriteCard = (WriteCardFunc)GetProcAddress(hDll, "WriteCard");
		if (!_WriteCard)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " WriteCard ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _WriteCard(zone, addr, len, sendData, receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:WriteCard쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// УԿ
/// </summary>
/// <param name="keyType">Կ</param>
/// <param name="key">Կ</param>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall ChkSecret(int keyType, char* key, char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		ChkSecretFunc _ChkSecret = (ChkSecretFunc)GetProcAddress(hDll, "ChkSecret");
		if (!_ChkSecret)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " ChkSecret ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _ChkSecret(keyType, key, receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:ChkSecret쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// дԿ
/// </summary>
/// <param name="keyType">Կ</param>
/// <param name="key">Կ</param>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall WriteSecret(int keyType, char* key, char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		WriteSecretFunc _WriteSecret = (WriteSecretFunc)GetProcAddress(hDll, "WriteSecret");
		if (!_WriteSecret)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " WriteSecret ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _WriteSecret(keyType, key, receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:WriteSecret쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ȡԿ
/// </summary>
/// <param name="keyType">Կ</param>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall ReadSecret(int keyType, char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		ReadSecretFunc _ReadSecret = (ReadSecretFunc)GetProcAddress(hDll, "ReadSecret");
		if (!_ReadSecret)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " ReadSecret ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _ReadSecret(keyType, receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:ReadSecret쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ʮַתΪֽ
/// </summary>
/// <param name="strData">ʮַ</param>
/// <param name="data">תֽ</param>
/// <returns></returns>
int __stdcall HexStrToByte(const char* strData, char* byteData) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		HexStrToByteFunc _HexStrToByte = (HexStrToByteFunc)GetProcAddress(hDll, "HexStrToByte");
		if (!_HexStrToByte)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " HexStrToByte ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _HexStrToByte(strData, byteData);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:HexStrToByte쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ֽתΪʮַ
/// </summary>
/// <param name="byteData">ֽ</param>
/// <param name="byteDataLen">鳤</param>
/// <param name="strData">תʮַ</param>
/// <returns></returns>
int __stdcall ByteToHexStr(char* byteData, unsigned int byteDataLen, char* strData) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		ByteToHexStrFunc _ByteToHexStr = (ByteToHexStrFunc)GetProcAddress(hDll, "ByteToHexStr");
		if (!_ByteToHexStr)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " ByteToHexStr ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _ByteToHexStr(byteData, byteDataLen, strData);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:HexStrToByte쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ʮֽתΪʮ
/// </summary>
/// <param name="byteData">ʮַ</param>
/// <param name="dec">תʮָ</param>
/// <returns></returns>
int __stdcall HexByteToDec(const char* byteData, unsigned long* dec) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		HexByteToDecFunc _HexByteToDec = (HexByteToDecFunc)GetProcAddress(hDll, "HexByteToDec");
		if (!_HexByteToDec)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " HexByteToDec ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _HexByteToDec(byteData, dec);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:HexByteToDec쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ʮתΪʮֽ
/// </summary>
/// <param name="dec">ʮ</param>
/// <param name="byteData">תʮֽ</param>
/// <returns></returns>
int __stdcall DecToHexByte(unsigned long dec, char* byteData) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		DecToHexByteFunc _DecToHexByte = (DecToHexByteFunc)GetProcAddress(hDll, "DecToHexByte");
		if (!_DecToHexByte)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " DecToHexByte ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _DecToHexByte(dec, byteData);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:DecToHexByte쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// Կ汾
/// </summary>
/// <param name="keyKind">Կ</param>
/// <param name="keyVer">Կ汾</param>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall SetKeyVersion(int keyKind, int keyVer, char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		SetKeyVersionFunc _SetKeyVersion = (SetKeyVersionFunc)GetProcAddress(hDll, "SetKeyVersion");
		if (!_SetKeyVersion)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " SetKeyVersion ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _SetKeyVersion(keyKind, keyVer, receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:SetKeyVersion쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// У1608Կ
/// </summary>
/// <param name="keyNo">Կ</param>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall Chk1608Secret(int keyNo, char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		Chk1608SecretFunc _Chk1608Secret = (Chk1608SecretFunc)GetProcAddress(hDll, "Chk1608Secret");
		if (!_Chk1608Secret)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " Chk1608Secret ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _Chk1608Secret(keyNo, receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:Chk1608Secret쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ֤1608
/// </summary>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall Authenfic1608(char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		Authenfic1608Func _Authenfic1608 = (Authenfic1608Func)GetProcAddress(hDll, "Authenfic1608");
		if (!_Authenfic1608)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " Authenfic1608 ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _Authenfic1608(receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:Authenfic1608쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ʮַתΪ޷ųֵ
/// </summary>
/// <param name="byteData">ʮֽ</param>
/// <param name="dec">ת޷ϳ</param>
/// <returns></returns>
int __stdcall HexByteToLong(const char* byteData, unsigned long* dec) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		HexByteToLongFunc _HexByteToLong = (HexByteToLongFunc)GetProcAddress(hDll, "HexByteToLong");
		if (!_HexByteToLong)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " HexByteToLong ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _HexByteToLong(byteData, dec);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:HexByteToLong쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ޷ųֵתΪʮֽ
/// </summary>
/// <param name="dec">޷ϳ</param>
/// <param name="byteData">תʮֽ</param>
/// <returns></returns>
int __stdcall LongToHexByte(unsigned long dec, char* byteData) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		LongToHexByteFunc _LongToHexByte = (LongToHexByteFunc)GetProcAddress(hDll, "LongToHexByte");
		if (!_LongToHexByte)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " LongToHexByte ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _LongToHexByte(dec, byteData);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:LongToHexByte쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ǩ
/// </summary>
/// <param name="idInfo">ʶϢ</param>
/// <param name="data"></param>
/// <param name="dataLen">ݳ</param>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall Signature(const char* idInfo, const char* data, int dataLen, char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		SignatureFunc _Signature = (SignatureFunc)GetProcAddress(hDll, "Signature");
		if (!_Signature)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " Signature ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _Signature(idInfo, data, dataLen, receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:Signature쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ֤ǩ
/// </summary>
/// <param name="idInfo">ʶϢ</param>
/// <param name="data"></param>
/// <param name="dataLen">ݳ</param>
/// <param name="signInfo">ǩϢ</param>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall VerifySignet(const char* idInfo, const char* data, int dataLen, const char* signInfo, char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		VerifySignetFunc _VerifySignet = (VerifySignetFunc)GetProcAddress(hDll, "VerifySignet");
		if (!_VerifySignet)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " VerifySignet ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _VerifySignet(idInfo, data, dataLen, signInfo, receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:VerifySignet쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// дʶϢ
/// </summary>
/// <param name="idInfo">ʶϢ</param>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall WriteIDInfo(const char* idInfo, char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		WriteIDInfoFunc _WriteIDInfo = (WriteIDInfoFunc)GetProcAddress(hDll, "WriteIDInfo");
		if (!_WriteIDInfo)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " WriteIDInfo ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _WriteIDInfo(idInfo, receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:WriteIDInfo쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// PIN
/// </summary>
/// <param name="iopType"></param>
/// <param name="slot">Ŀ豸</param>
/// <param name="pinData"> PIN </param>
/// <param name="pinDataLen"> PIN ݳ</param>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall PINOpfunc(int iopType, int slot, const char* pinData, int pinDataLen, char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		PINOpfuncFunc _PINOpfunc = (PINOpfuncFunc)GetProcAddress(hDll, "PINOpfunc");
		if (!_PINOpfunc)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " PINOpfunc ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _PINOpfunc(iopType, slot, pinData, pinDataLen, receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:PINOpfunc쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ±ʶϢ
/// </summary>
/// <param name="idInfo">ʶϢ</param>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall UpdateIDInfo(const char* idInfo, char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		UpdateIDInfoFunc _UpdateIDInfo = (UpdateIDInfoFunc)GetProcAddress(hDll, "UpdateIDInfo");
		if (!_UpdateIDInfo)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " UpdateIDInfo ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _UpdateIDInfo(idInfo, receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:UpdateIDInfo쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// û
/// </summary>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall LockUserCard(char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		LockUserCardFunc _LockUserCard = (LockUserCardFunc)GetProcAddress(hDll, "LockUserCard");
		if (!_LockUserCard)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " LockUserCard ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _LockUserCard(receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:LockUserCard쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ȡ SAM ʶϢ
/// </summary>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall ReadSamIDInfo(char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		ReadSamIDInfoFunc _ReadSamIDInfo = (ReadSamIDInfoFunc)GetProcAddress(hDll, "ReadSamIDInfo");
		if (!_ReadSamIDInfo)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " ReadSamIDInfo ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _ReadSamIDInfo(receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:ReadSamIDInfo쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// ȡICƬ
/// </summary>
/// <param name="slot">Ŀ</param>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall GetICCardNo(int slot, char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		GetICCardNoFunc _GetICCardNo = (GetICCardNoFunc)GetProcAddress(hDll, "GetICCardNo");
		if (!_GetICCardNo)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " GetICCardNo ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _GetICCardNo(slot, receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:GetICCardNo쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// SAMϵ
/// </summary>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall PowerOnSam(char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		PowerOnSamFunc _PowerOnSam = (PowerOnSamFunc)GetProcAddress(hDll, "PowerOnSam");
		if (!_PowerOnSam)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " PowerOnSam ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _PowerOnSam(receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:PowerOnSam쳣: " << ex.what() << std::endl;
		// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}
/// <summary>
/// GetUpdateIDRight
/// </summary>
/// <param name="icCardNo">IC</param>
/// <param name="hospitalId">ҽԺ</param>
/// <param name="receData">( 256 ֽ)</param>
/// <param name="receDataLen">ݳ</param>
/// <returns></returns>
int __stdcall GetUpdateIDRight(const char* icCardNo, const char* hospital, char* receData, unsigned long* receDataLen) {
	int ret = -1;
	try
	{
		// ȷĿDLL
		LoadTargetDll();
		GetUpdateIDRightFunc _GetUpdateIDRight = (GetUpdateIDRightFunc)GetProcAddress(hDll, "GetUpdateIDRight");
		if (!_GetUpdateIDRight)
		{
			// ʹ stringstream Ϣ
			std::ostringstream errorMessage;
			errorMessage << " GetUpdateIDRight ʧܣ: " << GetLastError();
			// ¼־
			logger->error(errorMessage.str());
			// ׳쳣Ϣ
			throw std::runtime_error(errorMessage.str());
		}
		ret = _GetUpdateIDRight(icCardNo, hospital, receData, receDataLen);
	}
	catch (const std::exception& ex)
	{
		// ʹ stringstream Ϣ
		std::ostringstream errorMessage;
		// 쳣ϸϢ
		errorMessage << "VC:GetUpdateIDRight쳣: " << ex.what() << std::endl;
			// ¼־
		logger->error(errorMessage.str());
		// ׳쳣Ϣ
		throw std::runtime_error(errorMessage.str());
	}
	return ret;
}